// Example 1-1. A simple C program
// circle.c: Calculate and print the areas of circles

#include <stdio.h>                 // Preprocessor directive

static double circularArea(double r);    // Function declaration (prototype form)

int main(void)                     // Definition of main() begins
{
    printf("    Areas of Circles\n\n");
    printf("     Radius              Area\n"
           "-----------------------------\n");

    double radius = 1.0L;
    double area = circularArea(radius);
    printf("%10.1f %10.2f\n", radius, area);

    radius = 5.0L;
    area = circularArea(radius);
    printf("%10.1f     %10.2f\n", radius, area);

    return 0;
}

// The function circularArea() calculates the area of a circle
// Parameter: The radius of the circle
// Return value: The area of the circle

static double circularArea(double r)      // Definition of circularArea() begins
{
    const double pi = 3.1415926536L;   // Pi is a constant
    return pi * r * r;
}
