// Example 3-1. Sample function error_exit()
// error_exit.c

#include <stdlib.h>
#include <stdio.h>

void error_exit(unsigned int error_n)   // Print a last error message
{
    // and exit the program.
    const char* error_msg[] = {"Unknown error code.\n",
                               "Insufficient memory.\n",
                               "Illegal memory access.\n"
                              };
    const size_t arr_len = sizeof(error_msg) / sizeof(error_msg[0]);

    if (error_n >= arr_len)
    {
        error_n = 0;
    }
    fputs(error_msg[error_n], stderr);
    exit(1);
}

#include <string.h>

#define PRG_NAME "EasyLine"
enum { e_unknown, e_nomem, e_badaddr };

int main(void)
{
    const char msg[] = "The installation of " PRG_NAME
                       " is now complete.";
    puts(msg);

    const char* p = msg + 100;
    if (p > (msg + strlen(msg)))
    {
        error_exit(e_badaddr);
    }
    puts(p);
    /* . . . */

    return EXIT_SUCCESS;
}
