// Example 7-8. Function binarySearch()
// binarySearch.c

#include <stdio.h>

// The binarySearch() function searches a sorted array.
// Arguments:    The value of the element to find;
//               the array of long to search; the array length.
// Return value: A pointer to the element found,
//               or NULL if the element is not present in the array.

const long* binarySearch(const long val, const long array[], const int n)
{
    const int m = n / 2;
    if (n <= 0)
    {
        return NULL;
    }
    if (val == array[m])
    {
        return array + m;
    }
    if (val < array[m])
    {
        return binarySearch(val, array, m);
    }
    else
    {
        return binarySearch(val, array + m + 1, n - m - 1);
    }
}

int main(void)
{
    const long lArr[] = {2L, 3L, 5L, 7L, 11L, 13L, 17L, 19L, 23L, 29L};
    const size_t len = sizeof(lArr) / sizeof(lArr[0]);

    for (int i = 0; i < len; ++i)
    {
        printf("%6ld", lArr[i]);
    }
    putchar('\n');

    printf("\nEnter a whole number: ");
    long value = 0;
    scanf("%ld", &value);

    const long* ptr = binarySearch(value, lArr, len);

    if (ptr == NULL)
    {
        printf("%ld is not an element of the array.\n", value);
    }
    else
    {
        const int n = ptr + 1 - lArr;
        printf("%ld is the %dth element in the array.\n", value, n);
    }
    return 0;
}
