// atomic_compare_exchange_ex.c : atomic_compare_exchange() example
// -------------------------------------------------------------

#include <stdatomic.h>
// _Bool atomic_compare_exchange_strong( volatile A *object,
//       C *expected, C desired);
// _Bool atomic_compare_exchange_strong_explicit( volatile A *object,
//       C *expected, C desired,
//       memory_order success, memory_order failure);
// _Bool atomic_compare_exchange_weak( volatile A *object,
//       C *expected, C desired);
// _Bool atomic_compare_exchange_weak_explicit( volatile A *object,
//       C *expected, C desired,
//       memory_order success, memory_order failure);

static long mulwith(volatile atomic_long* alPtr, long val)    // *=
{
    long old_val = (*alPtr);
    long new_val;  // new is not a reserved word in C

    do
    {
        new_val = old_val * val;
    }
    while (!atomic_compare_exchange_weak(alPtr, &old_val, new_val));

    return new_val;
}

#include <stdio.h>

int main(void)
{
    atomic_long a_value = 12L;
    mulwith(&a_value, 5L);

    printf("12 * 5 = %ld\n", a_value);
    return 0;
}
