// clock_ex.c : clock() example
// -------------------------------------------------------------

#include <time.h>      // clock_t clock( void );
#include <stdio.h>

int main(void)
{
    time_t start = {0};
    time(&start);
    for (long count = 0; count <= 500000000; ++count)
    {
        if (count % 1000000 != 0)
        {
            continue;   // measure only full millions
        }
        const clock_t ticks = clock();
        printf("Performed %ld million integer divisions; "
               "used %0.2f seconds of CPU time.\n", count / 1000000,
               (double) ticks / CLOCKS_PER_SEC);
    }
    time_t stop = {0};
    time(&stop);
    printf("Finished in about %.0f seconds.\n", difftime(stop, start));
    return 0;
}
