// coshh_ex.c : cosh() example
// -------------------------------------------------------------

#include <math.h>   // double cosh(double x);
// float coshf(float x);
// long double coshl(long double x);
#include <stdio.h>

int main(void)
{
    printf("Cosh(x) is the sum as n goes from 0 to infinity "
           "of x^(2*n) / (2*n)!\n");
    // That's x raised to the power of 2*n, divided by 2*n factorial.

    printf("Enter x and a maximum for n (separated by a space): ");
    double x = 0.0;
    unsigned int max_n = 0U;
    if (scanf(" %lf %u", &x, &max_n) < 2)
    {
        printf("Couldn't read two numbers.\n");
        return -1;
    }
    printf("cosh(%.2f) = %.4f;\n", x, cosh(x));

    double sum = 1.0;
    for (unsigned int n = 1U ; n <= max_n ; n++)
    {
        unsigned int factor = 2U * n; // Calculate (2*n)!
        unsigned int divisor = factor;

        while (factor > 1U)
        {
            factor--;
            divisor *= factor;
        }
        sum += pow(x, 2U * n) / divisor; // Accumulate the series
    }
    printf("Approximation by series of %u terms = %.4f.\n", max_n + 1U, sum);

    return 0;
}
