// erf_ex.c : erf() example
// -------------------------------------------------------------

#include <math.h>   // double erf( double x );
// float erff( float x );
// long double erfl( long double x );
#include <stdio.h>

/*
 * Given a normal distribution with mean 0 and standard deviation 1,
 * calculate the probability that the random variable is within the
 * range [0, 1.125]
 */

int main(void)
{
    const double sigma = 1.0;     // The standard deviation
    const double bound = 1.125;
    // probability that mean <= value <= bound
    const double probability = 0.5 * erf(bound / (sigma * sqrt(2.0)));

    printf("Given a normal distribution with mean 0 and standard deviation 1,\n"
           "the probability that a random variable is within the range [0, 1.125]\n"
           "is %lf.\n", probability);

    return 0;
}
