// exp_ex.c : exp() example
// -------------------------------------------------------------

#include <math.h>        // double exp( double x );
// float expf( float x );
// long double expl( long double x );
#include <stdio.h>

int main(void)
{
    /* Amount owed = principal * e^(interest_rate * time) */

    const int principal = 10000;   // Initial debt is ten thousand dollars.
    const double rate = 0.055;     // Interest rate is 5.5% annually.
    const double time = 1.5;       // Period is eighteen months.

    const int balance = principal * exp(rate * time);

    printf("Invest %d dollars at %.1f%% compound interest, and "
           "in %.1f years \nyou'll have %d dollars.\n",
           principal, rate * 100.0, time, balance);

    return 0;
}
