// fclose_ex.c : fclose() example
// -------------------------------------------------------------

#include <stdio.h>   // int fclose(FILE *fp);

/* Print a file to the console, line by line. */

int main(void)
{
    FILE* fp_infile = fopen("input.dat", "r");
    if (fp_infile == NULL)
    {
        fprintf(stderr, "Couldn't open input file.\n");
        return -1;
    }

    char linebuffer[512];
    while (fgets(linebuffer, sizeof(linebuffer), fp_infile) != NULL)
    {
        fputs(linebuffer, stdout);
    }
    if (! feof(fp_infile))         // This means "if not end of file"
    {
        fprintf(stderr, "Error reading from input file.\n");
    }
    if (fclose(fp_infile) != 0)
    {
        fprintf(stderr, "Error closing input file.\n");
        return -2;
    }

    return 0;
}
