// fgets_ex.c : fgets() example
// -------------------------------------------------------------

#include <stdio.h>   // char *fgets(char * restrict buffer, int n,
//              FILE * restrict fp);
#include <string.h>

int main(void)
{
    FILE* titlefile = fopen("titles.txt", "r");
    if (titlefile == NULL)
    {
        perror("Opening title file");
    }
    else
    {
        int counter = 0;
        char title[256];
        while (fgets(title, sizeof(title), titlefile) != NULL)
        {
            title[ strlen(title) - 1 ] = '\0';  // Trim off newline character.
            printf("%3d: \"%s\"\n", ++counter, title);
        }
        /* fgets() returned NULL: either EOF or an error occurred. */
        if (feof(titlefile))
        {
            printf("Total: %d titles.\n", counter);
        }
        fclose(titlefile);
    }
    return 0;
}
