// fgetws_ex.c : fgetws() example
// -------------------------------------------------------------

#include <stdio.h>
#include <wchar.h>   // wchar_t *fgetws(wchar_t * restrict buffer,
//                  int n, FILE * restrict fp);
//#include <stdlib.h>
#include <locale.h>

int main(void)
{
    if (setlocale(LC_CTYPE, "") == NULL)
    {
        fwprintf(stderr, L"Sorry, couldn't change to the system's native locale.\n");
        return -1;
    }
    FILE* fp_in_wide = fopen("local_in.txt", "r");
    if (fp_in_wide == NULL)
    {
        perror("Opening input file");
        return -1;
    }

    fwide(fp_in_wide, 1);

    wchar_t buffer[4096];
    const wchar_t* line = fgetws(buffer, sizeof(buffer), fp_in_wide);
    if (line == NULL)
    {
        perror("Reading from input file");
    }
    else
    {
        if (fputws(line, stdout) < 0)
        {
            perror("Writing to stdout");
        }
    }

    fclose(fp_in_wide);
    return 0;
}
