﻿// fputws_ex.c : fputws() example
// -------------------------------------------------------------

#include <wchar.h>   // int fputws(const wchar_t * restrict ws,
//              FILE * restrict fp);
#include <stdio.h>
#include <locale.h>

int main(void)
{
    if (setlocale(LC_CTYPE, "") == NULL)
    {
        fwprintf(stderr, L"Sorry, couldn't change to the system's native locale.\n");
        return -1;
    }
    const wchar_t widestring[] = L"How many umlauts are there in Fahrvergnügen?\n";

    const char fname_wide[] = "widetest.txt";
    FILE* fpw = fopen(fname_wide, "a");
    if (fpw == NULL)
    {
        perror("Opening output file");
        return -1;
    }

    // Set file to wide-character orientation:
    int widemodeflag = 1;  // >0 is wide
    widemodeflag = fwide(fpw, widemodeflag);
    if (widemodeflag <= 0)
    {
        fprintf(stderr, "Unable to set output file %s to wide characters\n",
                fname_wide);
        (void) fclose(fpw);
        return -1;
    }
    // Write wide-character string to the file:
    const int result = fputws(widestring, fpw);
    if (result < 0)
    {
        fprintf(stderr, "Error on writing file %s.\n", fname_wide);
        (void) fclose(fpw);
        return -1;
    }
    (void) fclose(fpw);
    return 0;
}
