// fseek_ex.c : fseek() example
// -------------------------------------------------------------

#include <stdio.h>   // int fseek(FILE *fp, long offset, int origin);

typedef struct
{
    long id;
    double value;
} record;

// void writeRecords();

int main(void)
{
    record cur_rec = (record)
    {
        0L, 0.0
    };
    const int reclength_file = sizeof(record);
    const long seek_id = 123L;

    FILE* fp = fopen("records", "rb");
    if (fp == NULL)
    {
        perror("Unable to open records file");
    }
    else
    {
        do
        {
            if (1 > fread(&cur_rec.id, sizeof(long), 1, fp))
            {
                fprintf(stderr, "Record with ID %ld not found.\n", seek_id);
                break;
            }
            else                                      // Skip rest of record
            {
                if (fseek(fp, reclength_file - sizeof(long), 1))
                {
                    perror("fseek failed");
                    break;
                }
            }
        }
        while (cur_rec.id != seek_id);

        if (cur_rec.id == seek_id)
        {
            printf("Record with ID %ld found.\n", seek_id);
        }

        fclose(fp);
    }
    return 0;
}
/*
void writeRecords()
{
    record someRecords[] = {{101L, 10.0L}, {123L, 20.0L}, {146L, 30.0L}};
    const size_t n = sizeof(someRecords)/sizeof(someRecords[0]);

    FILE* fp = fopen("records", "wb");
    if (fp == NULL)
    {
       perror("Unable to open records file");
    }
    else
    {
       if(fwrite(someRecords, sizeof(record), n, fp) < n)
       {
          perror("Unable to write records");
       }
       fclose(fp);
    }
}
*/
