﻿// mbsrtowcs_ex.c : mbsrtowcs() example
// -------------------------------------------------------------

#include <wchar.h>   // size_t mbsrtowcs(wchar_t * restrict dest, 
//                  const char ** restrict src,
//                  size_t n,
//                  mbstate_t * restrict state);
#include <string.h>
#include <locale.h>
#include <stdio.h>

int main(void)
{
    printf("The current locale is %s.\n", setlocale(LC_CTYPE, ""));

    const char mbstring[] = "This is originally a multibyte string.\n";
    const char* mbsptr = mbstring;
    wchar_t widestring[256] = {L'\0'};
    mbstate_t state;
    memset(&state, '\0', sizeof(state));

    const size_t result = mbsrtowcs(widestring, &mbsptr, (sizeof(widestring) / sizeof(widestring[0])), &state);
    if (result == (size_t) - 1)
    {
        fputs("Encoding error in multibyte string", stderr);
        return -1;
    }
    else
    {
        printf("Converted %zu multibyte characters. The result:\n", result);
        printf("%ls", widestring);
    }
    return 0;
}
