﻿// mbsrtowcs_s_ex.c : mbsrtowcs_s() example
// -------------------------------------------------------------
#ifndef __STDC_LIB_EXT1__
#error "This compiler does not support the C11 bounds-checking interfaces."
#endif

#define __STDC_WANT_LIB_EXT1__ 1

#include <wchar.h>   // errno_t mbsrtowcs_s(size_t * restrict retval,
//                     wchar_t * restrict dst,
//                     size_t dstmax,
//                     const char ** restrict src,
//                     size_t n,
//                     mbstate_t * restrict state );
#include <stdio.h>

int main(void)
{
    size_t len;                   // A buffer for wide characters
    wchar_t wcstr[10];            // and its capacity.
    const char* mbptr = "Any multibyte string";
    mbstate_t state = {0};

    if (mbsrtowcs_s(&len, wcstr, sizeof(wcstr) / sizeof(wcstr[0]),
                    &mbptr, sizeof(wcstr) / sizeof(wcstr[0]) - 1, &state) != 0)
    {
        printf("The array contains an invalid multibyte character.\n");
    }
    else
    {
        printf("Length: %zu; text: %ls\n", len, wcstr);
        printf("The remaining characters: %s\n", mbptr);
    }
    return 0;
}
