// perror_ex.c : perror() example
// -------------------------------------------------------------

#include <stdio.h>      // void perror(const char *string);
#include <errno.h>

#define MSGLEN_MAX (256)

int main(int argc, char* argv[])
{
    FILE* fp = fopen("nonexistentfile", "r");
    if (fp == NULL)
    {
        char msgbuf[MSGLEN_MAX] = "";
        snprintf(msgbuf, sizeof(msgbuf), "%s, function %s, file %s, line %d",
                 argv[0], __func__, __FILE__, __LINE__);
        perror(msgbuf);
        return errno;
    }
    fclose(fp);
    return 0;
}
