// snprintf_ex.c : snprintf() example
// -------------------------------------------------------------

#include <stdio.h>   // int snprintf(char * restrict dest, size_t n,
//               const char * restrict format, ...);

int main(void)
{
    char buffer[80];
    const double x = 1234.5;
    const double y = 678.9;
    const double z = -753.1;
    const double a = x * y + z;
    const int output_len = snprintf(buffer, sizeof(buffer),
                                    "For the input values %lf, %lf,"
                                    " and %lf,\nthe result was %lf.\n",
                                    x, y, z, a);
    puts(buffer);
    if (output_len >= sizeof(buffer))
    {
        fprintf(stderr, "Output string truncated! Lost %d characters.\n",
                output_len - (int) sizeof(buffer) + 1); // <--- bug
    }
    return 0;
}
