// sprintf_ex.c : sprintf() example
// -------------------------------------------------------------

#include <stdio.h>   // int sprintf(char * restrict dest, 
//              const char * restrict format, ...);

int main(void)
{
    char buffer[80];
    double x = 1234.5;
    double y = 678.9;
    double z = -753.1;
    double a = x * y + z;
    const int output_len = sprintf(buffer,
                                   "For the input values %lf, %lf, and %lf,"
                                   "\nthe result was %lf.\n",
                                   x, y, z, a);
    puts(buffer);
    if (output_len >= sizeof(buffer))
    {
        fprintf(stderr, "Output string overflowed by %d characters.\n"
                "The variables x, y, z and a may have been corrupted:\n"
                "x now contains %lf, y %lf, z %lf, and a %lf.\n",
                output_len - (int)sizeof(buffer) + 1, x, y, z, a);
    }
    return 0;
}
