﻿// wctomb_ex.c : wctomb() example
// -------------------------------------------------------------

#include <stdlib.h>   // int wctomb(char *s, wchar_t wc);
#include <wchar.h>
#include <stdio.h>
#include <limits.h>
#include <locale.h>

int main(void)
{
    printf("The current locale is %s.\n", setlocale(LC_CTYPE, ""));
    printf("The locale's multibyte encoding is %s.\n",
           (wctomb(NULL, L'\0') ? "stateful" : "stateless"));

    const wchar_t wcs[] = L"Wir stehen auf den Füßen von Riesen";
    char mbbuffer[MB_LEN_MAX] = { '\0' };
    int n = 0;
    int i = 0;
    do
    {
        n += wctomb(mbbuffer, wcs[i]);
    }
    while (wcs[i++] != L'\0');

    printf("The wide string \"%ls\" \nis %zu wide characters long.\n"
           "Its multibyte representation requires a buffer of %u bytes.\n",
           wcs, wcslen(wcs), n);

    return 0;
}
